pnmtopng(1)

NAME
pnmtopng - convert a portable anymap into a Portable Network Graphics file

SYNOPSIS
pnmtopng [-verbose] [-downscale] [-interlace] [-alpha file]
[-transparent [=]color] [-background color] [-gamma value]
[-hist] [-chroma wx wy rx ry gx gy bx by] [-phys x y unit]
[-text file] [-ztxt file] [-time [yy]yy-mm-dd hh:mm:ss]
[-filter type] [-compression level] [-force] [pnmfile]

DESCRIPTION
Reads a portable pixmap as input. Produces a Portable Network Graphics file as output.

Color values in PNG files are either eight or sixteen bits wide, so pnmtopng will automatically scale colors to have a maxval of 255 or 65535. Grayscale files will be produced with bit depths 1, 2, 4, 8 or 16. An extra pnmdepth step is not necessary.

OPTIONS

-verbose
    Display the format of the output file.

-downscale
    Enables scaling of maxvalues of more then 65535 to 16 bit. Since this means loss of image data, the step is not performed by default.

-interlace
    Creates an interlaced PNG file (Adam7).

-alpha file
    The alpha channel of pixel (or image) specifies the transparency of a pixel. To create this fourth pixel value a separate .pbm- or .pgm-file is needed. In this file black (0) stands for fully transparant and white (1) will become opaque. The sizes of both pbm/pgm/ppm-files must be the same. If the information contained in the alpha mask can also be represented as a transparency index, it will be used, since this should result in a smaller image file.

-transparent color
    ppmtogif marks the specified color as transparent in the PNG image. You specify the color as in ppmmake(1).E.g. red or rgb:ff/00/0d. If the color you specify is not present in the image, pnmtopnm selects instead the color in the image that is closest to the one you specify. Closeness is measured as a cartesian distance between colors in RGB space. If multiple colors are equidistant, pnmtopnm chooses one of them arbitrarily. However, if you prefix your color specification with "=", e.g. -transparent =red Only the exact color you specify will be transparent. If that color does not appear in the image, there will be no transparency. pnmtopng issues an information message when this is the case.

-background color
    To create a background color chunck in the png-file, which can be used for subsequent alpha-channel or transparent-color conversions. See -transparent for format of color.

-gamma value
    Creates an gAMA chunk. By providing the gamma-value of the pnm-file the software that lateron will display the png-file will be able to do the necessary gamma-corrections. A good rule-of-thumb is that when the file is created by a software program (like a CAD-program or a ray-tracer) the value is probably 1.0. When the pnm-file looks good on a non-gamma corrected PC display (which has itself a gamma-value of 2.2 - 2.8), a value of 0.45 should be given.

-hist
    Use this parameter to create a chunk that specifies the frequency (or histogram) of the colors in the image.

-chroma white point X and Y, red X and Y, green X and Y, and blue X and Y
    To specify the white point and rgb values following the CIE-1931 spec.

-phys x y unit
    When your image should not be displayed with square but with rectangular pixels this option should be used to create a pHYS chunk. When the unit-value is 0 the x and y only gives the ratio of pixel width and height. When it is 1 the x and y specify the number of pixels per meter.

-text file
    Allows to include comments in the text-chunk of the png-file. The format of the text-file is as follows: when the first column does not contain a blank or a tab, the first word is considered to be the keyword. For keywords to contain spaces, enclose them in double-quotes.
    When the first character on a line is a blank or tab, the rest of the line is a new line of the current comment. Note that the initial spaces are not considered to be part of the comment line.
    Here is an example:
    -------------------------------------------
    Title PNG-file
    Author your name
    Description how to include a text-chunk
                    into a PNG file
    "Creation date" 3-feb-1987
    Software pnmtopng
    -------------------------------------------

-ztxt file
    The same as -text, but now the text will be compressed.

-time yy-mm-dd hh:mm:ss or -time yyyy-mm-dd hh:mm:ss
    This option allows you to specify the (modification)time. The year parameter can be given as a two- or a four-digit value.

-filter type
    When the types of filters must be restricted you can specify here which filter you want to use. Allowed values are: 0 (none), 1 (sub), 2 (up), 3 (avg) and 4 (paeth).

-compression level
    To explicitly set the compression level of zlib use this parameter. Select a level between 0 for no compression (max speed) and 9 for maximum compression.

-force
    When set, -force limits the optimizations of pnmtopng. A png-file similar to the pnm-input is as much as possible enforced. For example no paletted files will be created and alpha-channel images will not be converted to images with a transparency chunck.

All flags can be abbreviated to their shortest unique prefix.

SEE ALSO
pngtopnm(1), gif2png(1), pnmgamma(1), pnm(5)

NOTE
Instead of xxxtopnm|pnmtopng, a specific converter should be used, if available. E.g. gif2png (GIF conversion), etc.

BUGS
There could be an option to read the comment text from pnm comments instead of a separate file.

The program could be much faster, with a bit of code optimizing.

AUTHORS
Copyright (C) 1995-1997 by Alexander Lehmann
                        and Willem van Schaik.